'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// this should be the entry point to your library

var SelectionPopover = function (_Component) {
  _inherits(SelectionPopover, _Component);

  function SelectionPopover(props) {
    _classCallCheck(this, SelectionPopover);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(SelectionPopover).call(this, props));

    _this._handlePopoverClick = function () {
      var showPopover = false;
      _this.setState({ showPopover: showPopover });
      _this.props.onChange({ showPopover: showPopover });
    };

    _this._handleMouseUp = function (e) {
      e.stopPropagation();
      var selection = document.getSelection();
      if (selection.toString().length) {
        var selectionBox = selection.getRangeAt(0).getBoundingClientRect();
        var showPopover = true;
        _this.setState({
          selectionBox: selectionBox,
          popoverBox: {
            width: _this.refs.selectionPopover.getBoundingClientRect().width,
            height: _this.refs.selectionPopover.getBoundingClientRect().height
          },
          showPopover: showPopover
        });
        _this.props.onChange({ showPopover: showPopover });
      } else {
        var _showPopover = false;
        _this.setState({ showPopover: _showPopover });
        _this.props.onChange({ showPopover: _showPopover });
      }
    };

    _this._handleWindowMouseUp = function () {
      var showPopover = false;
      _this.setState({ showPopover: showPopover });
      _this.props.onChange({ showPopover: showPopover });
    };

    _this.state = {
      showPopover: false,
      popoverBox: {
        width: 0,
        height: 0
      },
      selectionBox: {
        top: 0,
        left: 0,
        width: 0
      }
    };
    return _this;
  }

  _createClass(SelectionPopover, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var target = document.querySelectorAll('[data-selectable]')[0];
      target.addEventListener('mouseup', this._handleMouseUp);
      document.addEventListener('mouseup', this._handleWindowMouseUp);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var target = document.querySelectorAll('[data-selectable]')[0];
      target.removeEventListener('mouseup', this._handleMouseUp);
      document.removeEventListener('mouseup', this._handleWindowMouseUp);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var topOffset = _props.topOffset;

      var otherProps = _objectWithoutProperties(_props, ['children', 'style', 'topOffset']);

      var _state = this.state;
      var showPopover = _state.showPopover;
      var selectionBox = _state.selectionBox;
      var popoverBox = _state.popoverBox;

      var visibility = showPopover ? 'visible' : 'hidden';

      return _react2.default.createElement(
        'div',
        _extends({
          ref: 'selectionPopover',
          style: _extends({
            visibility: visibility,
            position: 'absolute',
            top: selectionBox.top - topOffset,
            left: selectionBox.width / 2 - popoverBox.width / 2 + selectionBox.left
          }, style)
        }, otherProps, {
          onClick: this._handlePopoverClick
        }),
        children
      );
    }
  }]);

  return SelectionPopover;
}(_react.Component);

SelectionPopover.propTypes = {
  children: _react.PropTypes.node.isRequired,
  style: _react.PropTypes.object,
  topOffset: _react.PropTypes.number,
  onChange: _react.PropTypes.func
};

SelectionPopover.defaultProps = {
  topOffset: 30
};

exports.default = SelectionPopover;